#![allow(bad_style)]

//! Tests Clone, Copy, Pod, Zeroable, Default (to zero), and PartialEq

use hektor::*;
use lokacore::{Pod, Zeroable};

fn is_clone<T: Clone>(_t: T) {}
fn is_copy<T: Copy>(_t: T) {}
fn is_pod<T: Pod>(_t: T) {}
fn is_zeroable<T: Zeroable>() -> T {
  T::zeroed()
}
fn is_default<T: Default>() -> T {
  T::default()
}

#[test]
fn Vec2_cl_cp_pod_0_def_peq() {
  is_clone(Vec2::default());
  is_copy(Vec2::default());
  is_pod(Vec2::default());
  //
  assert!(is_zeroable::<Vec2>() == is_default::<Vec2>());
}

#[test]
fn Vec3_cl_cp_pod_0_def_peq() {
  is_clone(Vec3::default());
  is_copy(Vec3::default());
  is_pod(Vec3::default());
  //
  assert!(is_zeroable::<Vec3>() == is_default::<Vec3>());
}

#[test]
fn Vec4_cl_cp_pod_0_def_peq() {
  is_clone(Vec4::default());
  is_copy(Vec4::default());
  is_pod(Vec4::default());
  //
  assert!(is_zeroable::<Vec4>() == is_default::<Vec4>());
}

#[test]
fn Mat2_cl_cp_pod_0_def_peq() {
  is_clone(Mat2::default());
  is_copy(Mat2::default());
  is_pod(Mat2::default());
  //
  assert!(is_zeroable::<Mat2>() == is_default::<Mat2>());
}

#[test]
fn Mat3_cl_cp_pod_0_def_peq() {
  is_clone(Mat3::default());
  is_copy(Mat3::default());
  is_pod(Mat3::default());
  //
  assert!(is_zeroable::<Mat3>() == is_default::<Mat3>());
}

#[test]
fn Mat4_cl_cp_pod_0_def_peq() {
  is_clone(Mat4::default());
  is_copy(Mat4::default());
  is_pod(Mat4::default());
  //
  assert!(is_zeroable::<Mat4>() == is_default::<Mat4>());
}

#[test]
fn Quat_cl_cp_pod_0_def_peq() {
  is_clone(Quat::default());
  is_copy(Quat::default());
  is_pod(Quat::default());
  //
  assert!(is_zeroable::<Quat>() == is_default::<Quat>());
}
