#![allow(bad_style)]

use hektor::*;

#[test]
fn Vec2_new() {
  assert_eq!(
    &format!("{:?}", Vec2::splat(7.0)),
    "Vec2 { x: 7.0, y: 7.0 }"
  );
}

#[test]
fn Vec3_new() {
  assert_eq!(
    &format!("{:?}", Vec3::splat(7.0)),
    "Vec3 { x: 7.0, y: 7.0, z: 7.0 }"
  );
}

#[test]
fn Vec4_new() {
  assert_eq!(
    &format!("{:?}", Vec4::splat(7.0)),
    "Vec4 { x: 7.0, y: 7.0, z: 7.0, w: 7.0 }"
  );
}

#[test]
fn Mat2_new() {
  assert_eq!(
    &format!("{:?}", Mat2::splat(7.0)),
    "Mat2 { x_axis: (7.0, 7.0), y_axis: (7.0, 7.0) }"
  );
}

#[test]
fn Mat3_new() {
  assert_eq!(
    &format!("{:?}", Mat3::splat(7.0)),
    "Mat3 { x_axis: (7.0, 7.0, 7.0), y_axis: (7.0, 7.0, 7.0), z_axis: (7.0, 7.0, 7.0) }"
  );
}

#[test]
fn Mat4_new() {
  assert_eq!(
    &format!("{:?}", Mat4::splat(7.0)),
    "Mat4 { x_axis: (7.0, 7.0, 7.0, 7.0), y_axis: (7.0, 7.0, 7.0, 7.0), z_axis: (7.0, 7.0, 7.0, 7.0), w_axis: (7.0, 7.0, 7.0, 7.0) }"
  );
}

#[test]
fn Quat_new() {
  assert_eq!(
    &format!("{:?}", Quat::splat(7.0)),
    "Quat { a: 7.0, b: 7.0, c: 7.0, d: 7.0 }"
  );
}
